/*
   inquiry.c: send `inquiry' command
*/
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <linux/../scsi/scsi.h>
#include "var.h"

#define INQUIRY_ALLOC_LEN 0xff

/*
   inquiry
*/
void inquiry ( char *fname )
{
  int status, addlen, fd;
  struct sg_header *sg;
  char *cdb = bufcdb + SCMD_HEADSIZ;
  char *res = bufres + SCMD_HEADSIZ;
  char buf[256];

  fd = open ( fname, O_RDWR );
  if ( fd < 0 ) {
    puts ( "*** 001 CAN'T OPEN" );
    fflush ( stdout );
    return;
  }

  *(cdb +  0) = INQUIRY;
  *(cdb +  1) = scsi_lun << 5;
  *(cdb +  2) = 0;
  *(cdb +  3) = 0;
  *(cdb +  4) = INQUIRY_ALLOC_LEN;
  *(cdb +  5) = 0;

  status = scsicmd ( fd, bufres, SCMD_RECVMAX, bufcdb, SCMD_HEADSIZ + 6 );
  close ( fd );

  if ( status ) {
    sg = (struct sg_header *)bufres;
    puts ( "*** 002 FAIL TO SEND COMMAND" );
    printf ( "set status %d\n", status );
    printf ( "set errcode %d\n", sg->sense_buffer[0] & 0x007f );
    printf ( "set sensekey %d\n", sg->sense_buffer[2] & 0x000f );
    printf ( "set asc %d\n", u8 (sg->sense_buffer[12]) );
    printf ( "set ascq %d\n", u8 (sg->sense_buffer[13]) );
    puts ( "===" );
    fflush ( stdout );
    return;
  }

  scsi_type = *(res + 0) & 0x1f;
  scsi_level = *(res + 3) & 0x07;

  fputs ( "set devtype  ", stdout );
  switch ( scsi_type ) {
  case 0x00: 
  case 0x01: 
  case 0x02: 
  case 0x03: 
  case 0x04: 
  case 0x05: 
  case 0x06: 
  case 0x07: 
  case 0x08: 
  case 0x09: 
  case 0x0a:
  case 0x0b:
  case 0x1f:
    printf ( "%d\n", scsi_type ); break;
  default:
    puts ( "default" ); break;
  }    

  printf ( "set mchange  %d\n", ( *(res+1) & 0x0080 ) != 0 );

  fputs  ( "set ansi     ", stdout );
  switch ( *(res + 2) & 0x07 ) {
  case 0: 
  case 1: 
  case 2: 
    printf ( "%d\n", *(res + 2) & 0x07 );
    break;
  default:
    printf ( "default\n", scsi_level );
  }
  
  printf ( "set ecma     %02X\n",
	  (*(res+2)>>3) & 0x0007 );
  printf ( "set iso      %02X\n",
	  (*(res+2)>>6) & 0x0003 );

  addlen = *(res+4);

  printf ( "set aenc     %d\n",
	  ( *(res+3) & 0x80 ) != 0 );
  printf ( "set trmiop   %d\n",
	  ( *(res+3) & 0x40 ) != 0 );
  printf ( "set reladr   %d\n",
	  ( *(res+7) & 0x80 ) != 0 );
  printf ( "set wbus32   %d\n",
	  ( *(res+7) & 0x40 ) != 0 );
  printf ( "set wbus16   %d\n",
	  ( *(res+7) & 0x20 ) != 0 );
  printf ( "set sync     %d\n",
	  ( *(res+7) & 0x10 ) != 0 );
  printf ( "set linked   %d\n",
	  ( *(res+7) & 0x08 ) != 0 );
  printf ( "set cmdque   %d\n",
	  ( *(res+7) & 0x02 ) != 0 );
  printf ( "set sftre    %d\n",
	  ( *(res+7) & 0x01 ) != 0 );

  strncpy ( buf, res+8, 8 ); buf[8] = '\0';
  printf ( "set vender   {%s}\n", buf );
  strncpy ( buf, res+16, 16 ); buf[16] = '\0';
  printf ( "set product  {%s}\n", buf );
  strncpy ( buf, res+32, 4 ); buf[4] = '\0';
  printf ( "set revision {%s}\n", buf );

  puts ( "===" );
  fflush ( stdout );
}
