/*
   makeerr.c: make a error sector
*/
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <linux/../scsi/scsi.h>
#include "var.h"

#define INITLEN 32767

void makeerr ( char *fname, int lbn )
{
  int status, addlen, fd;
  struct sg_header *sg;
  unsigned sensekey, asc, ascq;
  char *cdb = bufcdb + SCMD_HEADSIZ;
  char *res = bufres + SCMD_HEADSIZ;
  char buf[256];
  unsigned diff;
  unsigned datalen;
  int i;

  fd = open ( fname, O_RDWR );
  if ( fd < 0 ) {
    puts ( "*** 001 CAN'T OPEN" );
    fflush ( stdout );
    return;
  } 

  *(cdb +  0) = READ_LONG;
  *(cdb +  1) = scsi_lun << 5;
  *(cdb +  2) = u8 ( lbn >> 24 );
  *(cdb +  3) = u8 ( lbn >> 16 );
  *(cdb +  4) = u8 ( lbn >>  8 );
  *(cdb +  5) = u8 ( lbn >>  0 );
  *(cdb +  6) = 0;
  *(cdb +  7) = u8 ( INITLEN >> 8 );
  *(cdb +  8) = u8 ( INITLEN >> 0 );
  *(cdb +  9) = 0;

  status = scsicmd ( fd, bufres, SCMD_RECVMAX, bufcdb, SCMD_HEADSIZ + 10 );
  close ( fd );

  sg = (struct sg_header *)bufres;
  sensekey = sg->sense_buffer[2] & 0x000f;
  asc = u8 (sg->sense_buffer[12]);
  ascq = u8 (sg->sense_buffer[13]);
  if ( sensekey != ILLEGAL_REQUEST || asc != 0x24 || ascq != 0
      || sg->sense_buffer[0] & 0x0080 == 0
      || sg->sense_buffer[0] & 0x0020 == 0 ) {
    /* valid ӥåȤΩäƤʤΤǡǡǤʤ */
    puts ( "*** 003 NOT SUPPORTED" );
    fflush ( stdout );
    return;
  }

  diff = ((unsigned)(sg->sense_buffer[ 3]<<24))
    + ((unsigned)(sg->sense_buffer[ 4]<<16))
    + ((unsigned)(sg->sense_buffer[ 5]<< 8))
    + ((unsigned)(sg->sense_buffer[ 6]<< 0));
  datalen = INITLEN - diff;

  if ( SCMD_HEADSIZ + 10 + datalen > SCMD_RECVMAX ) {
    puts ( "*** 003 NOT SUPPORTED" );
    fflush ( stdout );
    return;
  }

  fd = open ( fname, O_RDWR );
  if ( fd < 0 ) {
    puts ( "*** 001 CAN'T OPEN" );
    fflush ( stdout );
    return;
  } 

  *(cdb +  0) = WRITE_LONG;
  *(cdb +  1) = scsi_lun << 5;
  *(cdb +  2) = u8 ( lbn >> 24 );
  *(cdb +  3) = u8 ( lbn >> 16 );
  *(cdb +  4) = u8 ( lbn >>  8 );
  *(cdb +  5) = u8 ( lbn >>  0 );
  *(cdb +  6) = 0;
  *(cdb +  7) = u8 ( datalen >> 8 );
  *(cdb +  8) = u8 ( datalen >> 0 );
  *(cdb +  9) = 0;

  for ( i = 0; i < datalen; ++i )
    *(cdb + 10 + i ) = random ();

  status = scsicmd ( fd, bufres, SCMD_RECVMAX,
		    bufcdb, SCMD_HEADSIZ + 10 + datalen );
  close ( fd );

  if ( status ) {
    sg = (struct sg_header *)bufres;
    puts ( "*** 002 FAIL TO SEND COMMAND" );
    printf ( "set status %d\n", status );
    printf ( "set sensekey %d\n", sg->sense_buffer[2] & 0x000f );
    printf ( "set errcode %d\n", sg->sense_buffer[0] & 0x007f );
    printf ( "set asc %d\n", u8 (sg->sense_buffer[12]) );
    printf ( "set ascq %d\n", u8 (sg->sense_buffer[13]) );
    puts ( "===" );
    fflush ( stdout );
    return;
  }
  puts ( "set status 0" );
  puts ( "===" );
  fflush ( stdout );
}
