/*
   modepage.c: get ModeSense/ModeSelect page list
*/
#include <stdio.h>
#include <linux/../scsi/scsi.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "var.h"

/*
   get modepage list
*/
void mode_page ( char *fname )
{
  int status, addlen, fd;
  struct sg_header *sg;
  
  char *cdb = bufcdb + SCMD_HEADSIZ;
  char *res = bufres + SCMD_HEADSIZ;
  char buf[256];
  int param_len, block_des, offset, page_len, media_type, device_uniq;
  int density;
  int i, j;

  fd = open ( fname, O_RDWR );
  if ( fd < 0 ) {
    puts ( "*** 001 CAN'T OPEN" );
    fflush ( stdout );
    return;
  }

  *(cdb +  0) = MODE_SENSE;
  *(cdb +  1) = scsi_lun << 5;
  *(cdb +  2) = 0x3f;
  *(cdb +  3) = 0;
  *(cdb +  4) = 0xff;
  *(cdb +  5) = 0;

  status = scsicmd ( fd, bufres, SCMD_RECVMAX, bufcdb, SCMD_HEADSIZ + 6 );
  close ( fd );

  if ( status ) {
    sg = (struct sg_header *)bufres;
    puts ( "*** 002 FAIL TO SEND COMMAND" );
    printf ( "set status %d\n", status );
    printf ( "set errcode %d\n", sg->sense_buffer[0] & 0x007f );
    printf ( "set sensekey %d\n", sg->sense_buffer[2] & 0x000f );
    printf ( "set asc %d\n", u8 (sg->sense_buffer[12]) );
    printf ( "set ascq %d\n", u8 (sg->sense_buffer[13]) );
    puts ( "===" );
    fflush ( stdout );
    return;
  }

  param_len = u8 ( *(res + 0) );
  media_type = u8 ( *(res + 1 ) );
  device_uniq = u8 ( *(res + 2 ) );
  block_des = u8 ( *(res + 3) )>> 3;

  puts ( "set parampage(0) {msense_header}" );
  offset = 4 + 8*block_des;
  while ( offset < param_len + 4 ) {
    page_len = u8 ( *(res+offset + 1) );
    switch ( *( res + offset ) & 0x003f ) {
      
    case 0x01:
      switch ( scsi_type ) {
      case TYPE_DISK:
      case TYPE_MOD:
      case TYPE_WORM:
      case TYPE_ROM:
	puts ( "set parampage(1) {msense_rwerr}" );
	break;
      default:
	break;
      }
      break;
      
    case 0x02:
      puts ( "set parampage(2) {msense_drconnect}" );
      break;
      
    case 0x03:
      switch ( scsi_type ) {
      case TYPE_DISK:
      case TYPE_MOD:
	puts ( "set parampage(3) {msense_format}" );
	break;
      case TYPE_PRINTER:
/*	puts ( "set parampage(3) {msense_pprinter}" );*/
	break;
      case TYPE_SCANNER:
/*	puts ( "set parampage(3) {msense_measure}" );*/
	break;
      default:
	break;
      }
      break;
      
    case 0x04:
      switch ( scsi_type ) {
      case TYPE_DISK:
	puts ( "set parampage(4) {msense_drive}" );
	break;
      case TYPE_PRINTER:
/*	puts ( "set parampage(4) {msense_sprinter}" );*/
	break;
      default:
	break;
      }
      break;
      
    case 0x05: 
      switch ( scsi_type ) {
      case TYPE_DISK:
/*	puts ( "set parampage(5) {msense_floppy}" );*/
	break;
      case TYPE_PRINTER:
/*	puts ( "set parampage(5) {msense_prtopt}" );*/
	break;
      default:
	break;
      }
      break;
      
    case 0x06:
      switch ( scsi_type ) {
      case TYPE_WORM:
      case TYPE_MOD:
/*	puts ( "set parampage(6) {msense_optmem}" );*/
	break;
      default:
	break;
      }
      break;
      
    case 0x07:
      switch ( scsi_type ) {
      case TYPE_DISK:
      case TYPE_WORM:
      case TYPE_MOD:
      case TYPE_ROM:
	puts ( "set parampage(7) {msense_vferr}" );
	break;
      default:
	break;
      }
      break;
      
    case 0x08:
      switch ( scsi_type ) {
      case TYPE_DISK:
      case TYPE_WORM:
      case TYPE_MOD:
	puts ( "set parampage(8) {msense_cache}" );
	break;
      default:
	break;
      }
      break;
      
    case 0x09:
/*      puts ( "set parampage(9) {msense_ppdev}" );*/
      break;
      
    case 0x0a:
      puts ( "set parampage(10) {msense_control}" );
      break;
      
    case 0x0b:
      switch ( scsi_type ) {
      case TYPE_DISK:
      case TYPE_WORM:
      case TYPE_MOD:
      case TYPE_ROM:
	puts ( "set parampage(11) {msense_mtype}" );
	break;
      default:
	break;
      }
      break;

    case 0x0d:
      switch ( scsi_type ) {
      case TYPE_ROM:
	puts ( "set parampage(13) {msense_cdrom}" );
	break;
      default:
	break;
      }
      break;

    case 0x0e:
      switch ( scsi_type ) {
      case TYPE_ROM:
	puts ( "set parampage(14) {msense_cdrom_audio}" );
	break;
      default:
	break;
      }
      break;

    default:
      printf ( "set unsupportedpage(%d) {unknown}\n", *( res + offset ) & 0x003f );
      break;
    }
    offset += page_len + 2;
  }
  puts ( "===" );
  fflush ( stdout );
}
