/*
   randomseek.c: randomseek benchmark
*/
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <linux/../scsi/scsi.h>
#include <signal.h>
#include "scsicmd.h"
#include "var.h"

static int sigcatch;

static void sighandle ( int );

/*
   randomseek: 
*/
void randomseek ( char *fname, int sec )
{
  int status, addlen, fd;
  int laststat, errcode, sensekey, asc, ascq;
  int wstatus, rstatus;
  struct sg_header *sg = (struct sg_header *)bufres;
  char *cdb = bufcdb + SCMD_HEADSIZ;
  char *res = bufres + SCMD_HEADSIZ;
  char buf[256];
  int count = 0;
  int bsiz;  long nblock;
  long bnum;

  readcap ( &bsiz, &nblock, fname );
  if ( bsiz < 0 ) {
    puts ( "*** 001 CAN'T OPEN" );
    fflush ( stdout );
    return;
  }
  ++nblock;

  fd = open ( fname, O_RDWR );
  if ( fd < 0 ) {
    puts ( "*** 001 CAN'T OPEN" );
    fflush ( stdout );
    return;
  }
  
  *(cdb +  0) = SEEK_10;
  *(cdb +  1) = scsi_lun << 5;
  *(cdb +  2) = 0;
  *(cdb +  3) = 0;
  *(cdb +  4) = 0;
  *(cdb +  5) = 0;
  *(cdb +  6) = 0;
  *(cdb +  7) = 0;
  *(cdb +  8) = 0;
  *(cdb +  9) = 0;

  sigcatch = 0;
  laststat = errcode = sensekey = asc = ascq = 0;

  signal ( SIGALRM, &sighandle );
  alarm ( sec );
  for ( count = 0; !sigcatch; ++count ) {
    bnum = random () % nblock;
    *(cdb + 2) = (bnum & 0x00ff000000) >> 24; 
    *(cdb + 3) = (bnum & 0x0000ff0000) >> 16;
    *(cdb + 4) = (bnum & 0x000000ff00) >>  8;
    *(cdb + 5) = (bnum & 0x00000000ff) >>  0;
    
    status = scsicmd ( fd, bufres, SCMD_HEADSIZ, bufcdb, SCMD_HEADSIZ + 10 );
    switch ( status ) {
    case SCMD_NORM_END:
    case SCMD_SEND_ERR:
    case SCMD_RECV_ERR:
      break;
    default:
      laststat = status;
      errcode = sg->sense_buffer[0] & 0x007f;
      sensekey = sg->sense_buffer[2] & 0x000f;
      asc = u8 (sg->sense_buffer[12]);
      ascq = u8 (sg->sense_buffer[13]);
      break;
    }
  }
  close ( fd );

  printf ( "set count    %d\n", count );
  printf ( "set status   %d\n", laststat );
  printf ( "set errcode  %d\n", errcode );
  printf ( "set sensekey %d\n", sensekey );
  printf ( "set asc      %d\n", asc );
  printf ( "set ascq     %d\n", ascq );
  puts ( "===" );
  fflush ( stdout );
}



static void sighandle ( int sig )
{
  if ( sig != SIGALRM ) {
    return; /* bad behavior ... */
  }
  sigcatch = 1;
}
