/*
   readcap.c: Read Capacity
*/
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <linux/../scsi/scsi.h>
#include "var.h"

void read_capacity ( char *fname )
{
  int status, addlen, fd;
  struct sg_header *sg;
  char *cdb = bufcdb + SCMD_HEADSIZ;
  char *res = bufres + SCMD_HEADSIZ;
  char buf[256];

  fd = open ( fname, O_RDWR );
  if ( fd < 0 ) {
    puts ( "*** 001 CAN'T OPEN" );
    fflush ( stdout );
    return;
  } 

  *(cdb +  0) = READ_CAPACITY;
  *(cdb +  1) = scsi_lun << 5;
  *(cdb +  2) = 0;
  *(cdb +  3) = 0;
  *(cdb +  4) = 0;
  *(cdb +  5) = 0;
  *(cdb +  6) = 0;
  *(cdb +  7) = 0;
  *(cdb +  8) = 0;
  *(cdb +  9) = 0;

  status = scsicmd ( fd, bufres, SCMD_RECVMAX, bufcdb, SCMD_HEADSIZ + 10 );
  close ( fd );
 
  if ( status ) {
    sg = (struct sg_header *)bufres;
    puts ( "*** 002 FAIL TO SEND COMMAND" );
    printf ( "set status %d\n", status );
    printf ( "set errcode %d\n", sg->sense_buffer[0] & 0x007f );
    printf ( "set sensekey %d\n", sg->sense_buffer[2] & 0x000f );
    printf ( "set asc %d\n", u8 (sg->sense_buffer[12]) );
    printf ( "set ascq %d\n", u8 (sg->sense_buffer[13]) );
    puts ( "===" );
    fflush ( stdout );
    return;
  }

  printf ( "set block_address %ld\n",
	( ( u8(*(res+0))*256L + u8 (*(res+1)))*256L
	 + u8(*(res+2)))*256L + u8(*(res+3)) + 0L
	  );
  printf ( "set block_len     %ld\n",
	( ( u8(*(res+4))*256L + u8 (*(res+5)))*256L
	 + u8(*(res+6)))*256L + u8(*(res+7)) + 0L
	  );
  puts ( "===" );
  fflush ( stdout );
}


/*
   readcap: for internal use
*/
void readcap ( int *bsiz, long *nblock, char *fname )
{
  int status, addlen, fd;
  struct sg_header *sg;
  char *cdb = bufcdb + SCMD_HEADSIZ;
  char *res = bufres + SCMD_HEADSIZ;
  char buf[256];

  fd = open ( fname, O_RDWR );
  if ( fd < 0 ) {
    *bsiz = *nblock = -1;
    return;
  } 

  *(cdb +  0) = READ_CAPACITY;
  *(cdb +  1) = scsi_lun << 5;
  *(cdb +  2) = 0;
  *(cdb +  3) = 0;
  *(cdb +  4) = 0;
  *(cdb +  5) = 0;
  *(cdb +  6) = 0;
  *(cdb +  7) = 0;
  *(cdb +  8) = 0;
  *(cdb +  9) = 0;

  status = scsicmd ( fd, bufres, SCMD_RECVMAX, bufcdb, SCMD_HEADSIZ + 10 );
  close ( fd );
 
  if ( status ) {
    *bsiz = *nblock = -1;
    return;
  }

  *nblock = ( ( u8(*(res+0))*256L + u8 (*(res+1)))*256L
	     + u8(*(res+2)))*256L + u8(*(res+3)) + 0L;

  *bsiz =( ( u8(*(res+4))*256L + u8 (*(res+5)))*256L
	  + u8(*(res+6)))*256L + u8(*(res+7)) + 0L;
}
