/*
   reassign.c: Reassign Block
*/
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <linux/../scsi/scsi.h>
#include "var.h"

void reassign ( char *fname, int lbn )
{
  int status, addlen, fd;
  struct sg_header *sg;
  char *cdb = bufcdb + SCMD_HEADSIZ;
  char *res = bufres + SCMD_HEADSIZ;
  char buf[256];
  unsigned diff;
  unsigned datalen;
  int i;

  fd = open ( fname, O_RDWR );
  if ( fd < 0 ) {
    puts ( "*** 001 CAN'T OPEN" );
    fflush ( stdout );
    return;
  } 

  *(cdb +  0) = REASSIGN_BLOCKS;
  *(cdb +  1) = scsi_lun << 5;
  *(cdb +  2) = 0;
  *(cdb +  3) = 0;
  *(cdb +  4) = 0;
  *(cdb +  5) = 0;

  *(cdb +  6) = 0;
  *(cdb +  7) = 0;
  *(cdb +  8) = 0;
  *(cdb +  9) = 4;

  *(cdb +  10) = u8 ( lbn >> 24 );
  *(cdb +  11) = u8 ( lbn >> 16 );
  *(cdb +  12) = u8 ( lbn >>  8 );
  *(cdb +  13) = u8 ( lbn >>  0 );

  status = scsicmd ( fd, bufres, SCMD_RECVMAX, bufcdb, SCMD_HEADSIZ + 14 );
  close ( fd );

  sg = (struct sg_header *)bufres;
  if ( status ) {
    puts ( "*** 002 FAIL TO SEND COMMAND" );
    printf ( "set status %d\n", status );
    printf ( "set sensekey %d\n", sg->sense_buffer[2] & 0x000f );
    printf ( "set errcode %d\n", sg->sense_buffer[0] & 0x007f );
    printf ( "set asc %d\n", u8 (sg->sense_buffer[12]) );
    printf ( "set ascq %d\n", u8 (sg->sense_buffer[13]) );
    puts ( "===" );
    fflush ( stdout );
    return;
  }

  puts ( "set status 0" );
  puts ( "===" );
  fflush ( stdout );
}
