/*
   verify.c: do verify
*/
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <linux/../scsi/scsi.h>
#include <signal.h>
#include "scsicmd.h"
#include "var.h"

#define BUFLEN ( 4096 - SCMD_HEADSIZ - 10 )
#define DPO   0x0010     /* å󥰶ػ */
#define VRFY_SIZ 0x0800
static int sigcatch;

static void sighandle ( int );

/*
   verify
*/
void verify ( char *fname )
{
  int status, addlen, fd;
  int laststat, errcode, sensekey, asc, ascq;
  int wstatus, rstatus;
  struct sg_header *sg = (struct sg_header *)bufres;
  char *cdb = bufcdb + SCMD_HEADSIZ;
  char *res = bufres + SCMD_HEADSIZ;
  char buf[256];
  int count = 0;
  int bsiz;  long nblock; long bnum;
  unsigned m, m1, m2, vsiz;
  int n;

  readcap ( &bsiz, &nblock, fname );

  if ( bsiz < 0 ) {
    puts ( "*** 001 CAN'T OPEN" );
    fflush ( stdout );
    return;
  }

  fd = open ( fname, O_RDWR );
  if ( fd < 0 ) {
    puts ( "*** 001 CAN'T OPEN" );
    fflush ( stdout );
    return;
  }

  *(cdb +  0) = VERIFY;
  *(cdb +  1) = (scsi_lun << 5);
  *(cdb +  2) = 0;
  *(cdb +  3) = 0;
  *(cdb +  4) = 0;
  *(cdb +  5) = 0;
  *(cdb +  6) = 0;
  *(cdb +  7) = VRFY_SIZ >> 8;
  *(cdb +  8) = VRFY_SIZ & 0x00ff;
  *(cdb +  9) = 0;

  sigcatch = 0;
  laststat = errcode = sensekey = asc = ascq = 0;

  for ( m = 0; m <= nblock ; m += VRFY_SIZ ) {
    vsiz = VRFY_SIZ;
    if ( m + vsiz - 1 > nblock ) {
      vsiz = nblock - m + 1;
    }
    *(cdb + 2) = (m & 0x00ff000000) >> 24; 
    *(cdb + 3) = (m & 0x0000ff0000) >> 16;
    *(cdb + 4) = (m & 0x000000ff00) >>  8;
    *(cdb + 5) = (m & 0x00000000ff) >>  0;
    *(cdb + 7) = vsiz >> 8;
    *(cdb + 8) = vsiz & 0x00ff;
    
    status = scsicmd ( fd, bufres, SCMD_HEADSIZ, bufcdb, SCMD_HEADSIZ + 10 );
    switch ( status ) {
    case SCMD_SEND_ERR:
    case SCMD_RECV_ERR:
      m -= vsiz;
      continue;
      break;
    case SCMD_NORM_END: /* 顼ʤơ */
      printf ( "set errblock -1; set progress %f\n", m/(double)nblock );
      fflush ( stdout );
      break;
    default: /* 顼ȯΤʰ֤Ĵ */
      errcode = sg->sense_buffer[0] & 0x007f;
      sensekey = sg->sense_buffer[2] & 0x000f;
      asc = u8 (sg->sense_buffer[12]);
      ascq = u8 (sg->sense_buffer[13]);
      if ( sensekey == ILLEGAL_REQUEST ) {
	close  ( fd );
	puts ( "*** 003 NOT SUPPORTED" );
	fflush ( stdout );
	return;
      }
      printf ( "set errblock -88; set block {%d --- %d}\n",
	      m, m + vsiz - 1 );
      fflush ( stdout );
      *(cdb +  7) = 0x00;
      *(cdb +  8) = 0x01;
      for ( m1 = m; m1 < m + vsiz - 1; ++m1 ) {
	*(cdb + 2) = (m1 & 0x00ff000000) >> 24; 
	*(cdb + 3) = (m1 & 0x0000ff0000) >> 16;
	*(cdb + 4) = (m1 & 0x000000ff00) >>  8;
	*(cdb + 5) = (m1 & 0x00000000ff) >>  0;
	status = scsicmd ( fd, bufres, SCMD_HEADSIZ, bufcdb,
			  SCMD_HEADSIZ + 10 );
	if ( status != SCMD_NORM_END ) {
	  printf ( "set errblock %d\n", m1 );
	  fflush ( stdout );
	}
      }
      break;
    }
  }
  close ( fd );

  puts ( "set errblock -1; set progress 1.0" );
  puts ( "===" );
  fflush ( stdout );
}
